public interface OrderedIntList {
    // OVERVIEW: una OrderedIntList è una lista
    // modificabile di interi ordinata in modo crescente.
    // Tipico elemento: [x1, ..., xn], dove xi<xj se i<j

    // costruttore senza parametri
    // NOTA: va realizzato nelle classi che implementano l'interfaccia
    // EFFECTS: inizializza this alla lista vuota
 
    // metodi 
    public void addEl (int el) throws DuplicateException; 
    // EFFECTS: aggiunge el a this, se el non occorre in 
    // this, altrimenti solleva DuplicateException  

    public void remEl (int el) throws NotFoundException; 
    // EFFECTS: toglie el da this, se el occorre in 
    // this, altrimenti solleva NotFoundException 

    public boolean isIn (int el); 
    // EFFECTS: se el appartiene a this ritorna
    // true, altrimenti false

    public boolean isEmpty (); 
    // EFFECTS: se this è vuoto ritorna true, altrimenti
    // false

    public int least () throws EmptyException; 
    // EFFECTS: se this è vuoto solleva EmptyException
    // altrimenti ritorna l’elemento minimo in this

    public int max () throws EmptyException; 
    // EFFECTS: se this è vuoto solleva EmptyException
    // altrimenti ritorna l’elemento massimo in this

    // Funzione di astrazione
    public String toString ();
    // EFFECTS: Restituisce una rappresentazione testuale 
    // di this, nel formato definito nell'OVERVIEW

    // Invariante di rappresentazione
    public boolean repOk ();
    // EFFECTS: restituisce true se this soddisfa l'invariante
    // di rappresentazione, false altrimenti
}

class EmptyException extends RuntimeException{
    public EmptyException(String s){
	super(s);
    }
}

class DuplicateException extends  RuntimeException{
    public DuplicateException(String s){
	super(s);
    }
 }

class NotFoundException extends  RuntimeException{
    public NotFoundException(String s){
	super(s);
    }
}
